/**
 * This class is for the sole propose of testing the libmysqlclient/taocrypt bug
 * @author Mariano Santamarina
 */

public class SQL2C 
{
	private Object lock=new Object();
	private long jconn;

	protected SQL2C() throws Exception
	{
		java.net.URL liburl=this.getClass().getClassLoader().getResource("libSQL2C.so");
		java.io.File f=new java.io.File(new java.net.URI(liburl.toString()));
		System.load(f.getAbsolutePath());

		jconn=sql_connect();
		if(jconn==0)
		{
			throw new Exception("Connection failed");
		}
	}


	private native long sql_connect();
	private native long sql_query(long conn,String sql);
	private native void sql_free(long rs);


	public RecordSet query(String sqlstr) throws Exception
	{
		long jrs;
		synchronized(lock)
		{
			jrs=sql_query(jconn,sqlstr);
		}
		if(jrs==0)
		{
			throw new Exception("Query Failed");
		}
		return(new RecordSet(jrs));
	}

	public class RecordSet 
	{
		private long jrs=0;

		protected RecordSet(long jrs) 
		{
			this.jrs=jrs;
		}

		protected void finalize() throws Throwable
		{
			synchronized(lock)
			{
				sql_free(jrs);
			}
		}

	}


	public static void main(String[] args)
	{
		try
		{
			SQL2C conn=new SQL2C();

			System.err.println(Runtime.getRuntime().totalMemory()-Runtime.getRuntime().freeMemory());

			for(;;)
			{
				for(int i=0;i<100;i++)
					conn.query("SELECT * FROM db");

				System.gc();
				System.err.println(Runtime.getRuntime().totalMemory()-Runtime.getRuntime().freeMemory());
			}
		} catch (Exception e)
		{
			e.printStackTrace();
		}
	}
}
